#!/usr/bin/perl
#
################################################################################
#
# IPCop Uptime Web-Iface
#
# Copyright (C) 2007-2008 Olaf (weizen_42) Westrik
#
# This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA
#
#
# Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License, wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version.
#
# Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.
#
# Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem Programm erhalten haben. Falls nicht, schreiben Sie an die Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
#
################################################################################
#
# For support post / read in http://www.ipcop-forum.de
#
# $Id: coptime.cgi 310 2008-05-26 18:43:38Z weizen_42 $
#
# Revision history:
#
# 2007-02-xx created by weizen_42 at ipcop-forum dot de
# 2007-02-19 v0.0.3 added dotzball indicator
# 2007-02-19 v0.0.4 modified enabled/disabled handling
# 2007-02-20 v0.0.5 display status text from server
# 2007-02-21 v0.1.0 field for image
# 2007-02-22 v0.1.2 image also displayed
# 2007-02-22 v0.1.5 dotzball, added page with std pictures
# 2007-02-22 v0.2.0 added galerie and display BBCode image link
# 2007-03-12 v0.3.0 get rid of usedonlyonce warning, uptime-pic links to personal info page now
# 2007-04-01 v0.3.1 can use picture list with upstream proxy
#
#   now in SVN
#


use strict;

# enable only the following on debugging purpose
use warnings;
use CGI::Carp 'fatalsToBrowser';

use IO::Socket;
use LWP::UserAgent;

require '/var/ipcop/general-functions.pl';
require '/var/ipcop/lang.pl';
require '/var/ipcop/header.pl';


my $version = 'v0.4.2';
my $serverurl = 'http://www.ipcop-forum.de/coptime';
# checking for new version
my $addonname = 'coptime';
my $onlineversion = '';
my $onlinelink = '';
my $timestamplastcheck = '/var/ipcop/coptime/lastcheck';
my $flagdonotcheck = '/var/ipcop/coptime/noversioncheck';
my $coptimeimage = '&nbsp;';
my $errormessage = '';
my $ua = LWP::UserAgent->new;

# get rid of used only once warnings
my @onlyonce = ( $Header::colourred );
undef @onlyonce;

my %data = ();
$data{'ENABLED'} = '';
$data{'UPTIME_ID'} = 0;
$data{'PASSWORD'} = '';
&General::readhash("${General::swroot}/coptime/settings", \%data) if ( -e "${General::swroot}/coptime/settings" );

my %checked = ();
my %cgiparams = ();
$cgiparams{'ENABLED'} = '';             #
$cgiparams{'INDEXCGI'} = '';            #
$cgiparams{'ACTION'} = '';              # save
$cgiparams{'UPTIME_ID'} = '';           #
$cgiparams{'PASSWORD'} = '';            #
$cgiparams{'IMAGE'} = '';               #
$cgiparams{'GALERIE'} = '';             #
&Header::getcgihash(\%cgiparams);


if ( $cgiparams{'ACTION'} eq $Lang::tr{'save'} )
{
  $data{'ENABLED'} = $cgiparams{'ENABLED'};
  $data{'INDEXCGI'} = $cgiparams{'INDEXCGI'};
  $data{'UPTIME_ID'} = $cgiparams{'UPTIME_ID'};
  $data{'PASSWORD'} = $cgiparams{'PASSWORD'};
  $data{'IMAGE'} = $cgiparams{'IMAGE'};
  $data{'GALERIE'} = $cgiparams{'GALERIE'};

  &General::writehash("${General::swroot}/coptime/settings", \%data);
}

if ( $cgiparams{'ACTION'} eq $Lang::tr{'CopTime select pic'} )
{
	unless(defined($cgiparams{'PICNAME'}))
	{
		$errormessage .= "$Lang::tr{'CopTime no pic selected'}<br />\n";
		$cgiparams{'ACTION'} = '>';
	}
	else
	{
		$data{'IMAGE'} = $cgiparams{'PICNAME'};
    &General::writehash("${General::swroot}/coptime/settings", \%data);
	}
}

if ( ($errormessage eq '')
	&& (($cgiparams{'ACTION'} eq $Lang::tr{'CopTime update'})
		|| ($cgiparams{'ACTION'} eq $Lang::tr{'save'})
		|| ($cgiparams{'ACTION'} eq $Lang::tr{'CopTime select pic'})
		) )
{
  system("/usr/local/bin/coptime.pl fcron > /dev/null");
}

&Header::showhttpheaders();
&Header::openpage($Lang::tr{'CopTime'}, 1, '');
&Header::openbigbox('100%', 'left', '', '');

if ($errormessage)
{
	&Header::openbox('100%', 'left', $Lang::tr{'error messages'});
	print "<font color='${Header::colourred}'> $errormessage\n</font>";
	&Header::closebox();
}

if ($cgiparams{'ACTION'} eq '>')
{
	&runPicturePage();
}
else
{
	&runStdPage();
}

&Header::closebigbox();
&Header::closepage();


sub runStdPage
{
	# set to off/on
	$data{'ENABLED'} = 'off' if( $data{'ENABLED'} ne 'on' );

	my %status = ();
	$status{'STATUS'} = '';
	$status{'CONTACT'} = '';
	$status{'AVERAGE'} = '';
	$status{'RECORD'} = '';
	$status{'RANK'} = 0;
	&General::readhash("/var/log/coptime/status", \%status) if ( -e "/var/log/coptime/status" );

	if ( $data{'ENABLED'} eq 'off' )
	{
	  $status{'STATUS'} = $Lang::tr{'CopTime disabled'} ;
	}
	else
	{
	  my $st = "CopTime ".$status{'STATUS'};
	  $status{'STATUS'} = $Lang::tr{$st} if ( $Lang::tr{$st} ne '' );
	  $status{'STATUS'} = "<b>".$status{'STATUS'}."</b>" unless ( $status{'STATUS'} eq $Lang::tr{'CopTime OK'} );
	}

	if ( -e "${General::swroot}/red/active" && ($data{'ENABLED'} eq 'on') ) {
		$coptimeimage = "<a href='http://www.ipcop-forum.de/coptime/coptimer-info.php?uptime_id=". $data{"UPTIME_ID"} ."' target='_blank'><img src='" . $serverurl . "/img/" . $data{'UPTIME_ID'} . ".png' alt='CopTime image' /></a>";
	}

	# Found this usefull piece of code in BlockOutTraffic AddOn  8-)
	#   fwrules.cgi
	###############
	# DEBUG DEBUG
	#&Header::openbox('100%', 'left', 'DEBUG');
	#my $debugCount = 0;
	#foreach my $line (sort keys %cgiparams) {
	#  print "$line = '$cgiparams{$line}'<br />\n";
	#  $debugCount++;
	#}
	#print "&nbsp;Count: $debugCount\n";
	#&Header::closebox();
	# DEBUG DEBUG
	###############


	$checked{'ENABLED'}{'off'} = '';
	$checked{'ENABLED'}{'on'} = '';
	$checked{'ENABLED'}{$data{'ENABLED'}} = "checked='checked'";

	$checked{'INDEXCGI'}{'off'} = '';
	$checked{'INDEXCGI'}{'on'} = '';
	$checked{'INDEXCGI'}{$data{'INDEXCGI'}} = "checked='checked'";

	#
	# Check for new version
	#
	&checkfornewversion($addonname, $version);
	if ( $onlineversion ne '' )
	{
	  &Header::openbox('100%', 'left', $Lang::tr{'info'});
	  print <<END
	<table width="100%"><tr>
	<td>$Lang::tr{'CopTime newversion'} <a href="$onlinelink" target="_blank"><b>$onlineversion</b></a></td>
	</tr></table>
END
;
	  &Header::closebox();
	}


	##########
	#
	# Box with status
	#
	##########

	&Header::openbox('100%', 'left', $Lang::tr{'status'});

	print <<END
	<form method='post' action='$ENV{'SCRIPT_NAME'}'>
	<table width='100%'>
	<tr valign='top'>
		<td align='left' width='25%'>$Lang::tr{'status'}:&nbsp;</td>
		<td align='left' width='40%'>$status{'STATUS'}</td>
		<td align='right' valign='top' rowspan='8'><a href='http://www.ipcop-forum.de/coptime/' target='_blank'><img src='/images/coptime_gui.png'></a></td>
	</tr>
END
;

	if($data{'ENABLED'} eq 'on')
	{
	  print <<END
	<tr>
		<td align='left' width='25%'>$Lang::tr{'CopTime contact'}:&nbsp;</td>
		<td align='left' width='40%'>$status{'CONTACT'}</td>
	</tr><tr>
		<td align='left' width='25%'>$Lang::tr{'CopTime uptime'}:&nbsp;</td>
		<td align='left' width='40%'>$status{'UPTIME'}</td>
	</tr><tr>
		<td align='left' width='25%'>$Lang::tr{'CopTime record'}:&nbsp;</td>
		<td align='left' width='40%'>$status{'RECORD'}</td>
	</tr><tr>
		<td align='left' width='25%'>$Lang::tr{'CopTime average'}:&nbsp;</td>
		<td align='left' width='40%'>$status{'AVERAGE'}</td>
	</tr><tr>
		<td align='left' width='25%'>$Lang::tr{'CopTime rank'}:&nbsp;</td>
		<td align='left' width='40%'>$status{'RANK'}</td>
	</tr><tr>
		<td align='left' width='25%'>&nbsp;</td>
	  <td align='left' width='40%'><input type='submit' name='ACTION' value='$Lang::tr{'CopTime update'}' /></td>
	</tr>
END
;
	}

	print <<END
	</table>
	<hr />
	<table width='100%'>
	<tr>
		<td align='left' width='25%'>&nbsp;</td>
		<td align='right'><b><small><a href='http://www.ipcop-forum.de/coptime/' target='_blank'>CopTime $version</a></small></b></td>
	</tr>
	</table>
END
;

	&Header::closebox();

	##########
	#
	# Box with config / settings
	#
	##########

	my $bbcodelink = " [url=http://www.ipcop-forum.de/coptime/][img]http://www.ipcop-forum.de/coptime/img/" . $data{"UPTIME_ID"} . ".png[/img][/url]";

	&Header::openbox('100%', 'left', "$Lang::tr{'settings'}");
	print <<END
	<table width='100%' border='0' cellspacing='1' cellpadding='0'>
	<tr>
	  <td align='left' width='25%'>$Lang::tr{'CopTime enabled'}:&nbsp;</td>
	  <td width='30%' class='base'><input type='checkbox' name='ENABLED' $checked{'ENABLED'}{'on'} /></td>
	  <td width='45%' align='right' valign='top' rowspan='5'>$coptimeimage</td>
	</tr><tr>
	  <td align='left' width='25%'>$Lang::tr{'CopTime indexcgi'}:&nbsp;</td>
	  <td width='30%' class='base'><input type='checkbox' name='INDEXCGI' $checked{'INDEXCGI'}{'on'} /></td>
	</tr><tr>
	  <td align='left' width='25%'>$Lang::tr{'CopTime uptime_id'}:&nbsp;</td>
	  <td width='30%' class='base'><input type='text' name='UPTIME_ID' value='$data{"UPTIME_ID"}' size='20' /></td>
	</tr><tr>
	  <td align='left' width='25%'>$Lang::tr{'password'}&nbsp;</td>
	  <td width='30%' class='base'><input type='password' name='PASSWORD' value='$data{"PASSWORD"}' size='20' /></td>
	</tr><tr>
	  <td align='left' width='25%'>$Lang::tr{'CopTime image'}:&nbsp;</td>
	  <td width='30%' class='base'>
		<input type='text' name='IMAGE' value='$data{"IMAGE"}' size='20' />&nbsp;
		<input type='submit' name='ACTION' value=' &gt; ' />
	  </td>
	</tr><tr>
	  <td align='left' width='25%'>$Lang::tr{'CopTime galerie'}:&nbsp;<img src='/blob.gif' alt='*' /></td>
	  <td width='30%' class='base'><input type='text' name='GALERIE' value='$data{"GALERIE"}' size='20' />&nbsp;
	  <td width='45%' align='right'>&nbsp;</td>
	</tr><tr><td colspan='3'><img src='/images/null.gif' width='0' height='5' border='0' alt='' /></td>
	</tr><tr>
	  <td align='left' width='25%'>$Lang::tr{'CopTime bbcode'}:&nbsp;</td>
	  <td class='base' colspan='2'>$bbcodelink</td>
	</tr></table>
	<hr />
	<table width='100%'>
	<tr>
	  <td width='70%' class='base' valign='top'><img src='/blob.gif' alt='*' />&nbsp;$Lang::tr{'this field may be blank'}</td>
	  <td width='30%'><input type='submit' name='ACTION' value='$Lang::tr{'save'}' /></td>
	</tr>
	</table>
	</form>
END
;

	&Header::closebox();
}

sub runPicturePage
{
	&Header::openbox('100%', 'left', $Lang::tr{'CopTime std pictures'});

	print "		<form method='post' action='$ENV{'SCRIPT_NAME'}'>\n";
	my $selectDisabled = '';

	if ( ! -e '/var/ipcop/red/active')
	{
		print "$Lang::tr{'CopTime must be online'}<br />\n";
		$selectDisabled = "disabled='disabled'";
	}
	else
	{
		prepare_ua();
		$ua->timeout(120);
		my $content = $ua->get($serverurl . "/pictureList.xml");
#		my $content = $ua->get("http://localhost:81/pictureList.xml");

		my %allPictures = ();
		if ( $content->is_success )
		{
			my $line = $content->content;

			# get XML content in one line
			$line =~ s/\s+/ /g;

			# DEBUG
			#print "line 1: $line<br />\n";

			while ( $line =~ /<name>(\w+)<\/name>\s*<file>(\w+\.\w+)<\/file>\s*(.*)$/)
			{
				$line = $3;
				$allPictures{$1}{'name'} = $1;
				$allPictures{$1}{'file'} = $2;

				#DEBUG
				#print "line 2: $line<br />\n";
			}
		}

		my @picNames = sort keys %allPictures;
		print <<END
			<table width='100%' border='0' cellspacing='1' cellpadding='0'>
END
;
		my $count = @picNames;
		# DEBUG
		#print "count: $count<br />\n";
		my $halfCount = $count / 2;

		# if there is a odd count of pictures we have to tricks a bit
		if($count % 2 == 1)
		{
			# DEBUG
			#print "odd number<br />\n";
			$halfCount = ($count + 1) / 2;
		}

		# DEBUG
		#print "half count: $halfCount<br />\n";

		my $id = 0;
		while ($id < $halfCount)
		{
			my $nameLeft = $picNames[$id];

			my $selectedLeft = '';
			$selectedLeft = "checked='checked'" if($nameLeft eq $data{"IMAGE"});


			print <<END
			<tr>
				<td align='left' width='15%'>
					<input type='radio' name='PICNAME' value='$nameLeft' $selectedLeft />&nbsp;
					$nameLeft:
				</td>
				<td align='left' width='35%'>
					<img src='$serverurl/gfx/$allPictures{$nameLeft}{'file'}' alt='CopTime image' />
				</td>
END
;
			my $idRight = $id + $halfCount;
			if(defined $picNames[$idRight])
			{
				my $nameRight = $picNames[$idRight];
				my $selectedRight = '';
				$selectedRight = "checked='checked'" if($nameRight eq $data{"IMAGE"});


				print <<END
				<td align='left' width='15%'>
					<input type='radio' name='PICNAME' value='$nameRight' $selectedRight />&nbsp;
					$nameRight:
				</td>
				<td align='left' width='35%'>
					<img src='$serverurl/gfx/$allPictures{$nameRight}{'file'}' alt='CopTime image' />
				</td>
END
;
			}
			else
			{
				print "				<td colspan='2'></td>\n";
			}
			print <<END
			</tr>
			<tr>
				<td colspan='4'><img src='/images/null.gif' width='0' height='5' border='0' alt='' /></td>
			</tr>
END
;

			$id++;
		}

		print "			</table>\n";
	}
	print <<END
			<hr />
			<table width='100%'>
			<tr>
			  <td width='40%' class='base'></td>
			  <td width='30%'><input type='submit' name='ACTION' value='&lt;' /></td>
			  <td width='30%'><input type='submit' name='ACTION' value='$Lang::tr{'CopTime select pic'}' $selectDisabled/></td>
			</tr>
			</table>
		</form>
END
;


	&Header::closebox();
}


sub prepare_ua()
{
  $ua->timeout(15);
  $ua->agent("Mozilla/4.0 (compatible; IPCop $General::version; $version)");

  # upstream proxy
  my %proxysettings=();
  &General::readhash("${General::swroot}/proxy/settings", \%proxysettings);

  if ( $_ = $proxysettings{'UPSTREAM_PROXY'} )
  {
    my ($peer, $peerport) = (/^(?:[a-zA-Z ]+\:\/\/)?(?:[A-Za-z0-9\_\.\-]*?(?:\:[A-Za-z0-9\_\.\-]*?)?\@)?([a-zA-Z0-9\.\_\-]*?)(?:\:([0-9]{1,5}))?(?:\/.*?)?$/);
    if ( $proxysettings{'UPSTREAM_USER'} )
    {
      $ua->proxy("http","http://$proxysettings{'UPSTREAM_USER'}:$proxysettings{'UPSTREAM_PASSWORD'}@"."$peer:$peerport/");
    } 
    else 
    {
      $ua->proxy("http","http://$peer:$peerport/");
    }
  }
}


sub checkfornewversion
{
  my $addon = shift;
  my $version = shift;
  $onlineversion = '';

  if ( -e $flagdonotcheck )
  {
    return;
  }

  # only check if we are online and last check was some time ago
  if ( (! -e '/var/ipcop/red/active') || (-e $timestamplastcheck) && (int(-M $timestamplastcheck) < 5) )
  {
    return;
  }

#workaround to suppress a warning when a variable is used only once
  my @dummy = ( $General::version );
  undef (@dummy);

  my $ua = LWP::UserAgent->new;
  $ua->timeout(120);
  $ua->agent("Mozilla/4.0 (compatible; IPCop $General::version; $version)");
  my $content = $ua->get("http://ipcop-addons.ath.cx/version/$addon");

  if ( $content->is_success )
  {
    # compare the versions, format is v1.2.3
    $content->content =~ /v(\d+).(\d+).(\d+)/;
    my $ver1 = $1;
    my $ver2 = $2;
    my $ver3 = $3;

    $version =~ /v(\d+).(\d+).(\d+)/;

    if ( ($ver1 > $1) || (($ver1 == $1) && ($ver2 > $2)) || (($ver1 == $1) && ($ver2 == $2) && ($ver3 > $3)) )
    {
      $onlineversion = "v$ver1.$ver2.$ver3";

      $content->content =~ /http(.*)/;
      $onlinelink = "http$1";
    }
    else
    {
      # no news, recheck in a couple of days
      system("touch $timestamplastcheck");
    }
  }
}
